//
//  TouchScene.cpp
//  layer_touch_single
//
//  Created by Reza Ghobadinic on 2019-10-27.
//

#include "TouchScene.h"
#include <iostream>

USING_NS_CC;
using namespace std;

Scene* TouchScene::createScene()
{
    auto scene = Scene::create();
    auto layer = TouchScene::create();
    
    scene->addChild(layer);
    
    return scene;
}

bool TouchScene::init()
{
    auto circle = Sprite::create("circle.png");
    circle->setVisible(false);
    this->addChild(circle);
    
    auto listener = EventListenerTouchOneByOne::create(); // Create a single touch listener
    
    listener->onTouchBegan = [circle] (Touch *touch, Event *event) -> bool
    {
        auto id  = touch->getID();
        auto pos = touch->getLocation();
        auto loc = touch->getLocationInView();
        circle->setVisible(true);
        circle->setPosition(pos);
        cout << "onTouchBegan : " << id;
        cout << " pos : " << pos.x << " " << pos.y;
        cout << " loc : " << loc.x << " " << loc.y  << endl;
        return true;
    };
    
    listener->onTouchMoved = [circle] (Touch *touch, Event *event)
    {
        auto id  = touch->getID();
        auto pos = touch->getLocation();
        auto loc = touch->getLocationInView();
        circle->setPosition(pos);
        cout << "onTouchMoved : " << id;
        cout << " pos : " << pos.x << " " << pos.y;
        cout << " loc : " << loc.x << " " << loc.y  << endl;
    };
    
    listener->onTouchEnded = [circle] (Touch *touch, Event *event)
    {
        auto id  = touch->getID();
        circle->setVisible(false);
        cout << "onTouchEnded : " << id << endl;
    };
    
    listener->onTouchCancelled = [circle] (Touch *touch, Event *event)
    {
        auto id  = touch->getID();
        circle->setVisible(false);
        cout << "onTouchCancelled : " << id << endl;
    };
    
    _eventDispatcher->addEventListenerWithSceneGraphPriority(listener, this);
    
    return true;
}
